/*
 *COPYRIGHT LICENSE: This information contains sample code provided in source code form.
 * You may copy, modify, and distribute these sample programs in any form without payment
 * to IBM for the purposes of developing, using, marketing or distributing application
 * programs conforming to the application programming interface for the operating platform
 * for which the sample code is written.
 *
 * Notwithstanding anything to the contrary, IBM PROVIDES THE SAMPLE SOURCE CODE ON 
 * AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING,
 * BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS OF MERCHANTABILITY,
 * SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND ANY WARRANTY OR
 * CONDITION OF NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR OPERATION OF
 * THE SAMPLE SOURCE CODE. IBM HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,
 * UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE SAMPLE SOURCE CODE.
 *
 * (C) Copyright IBM Corp. 2001, 2013.
 * All Rights Reserved. Licensed Materials - Property of IBM.
 */
package com.ibm.ws.samples.icefaces.manager;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import com.ibm.ws.samples.icefaces.bean.PhoneBookEntry;

public class MockPhoneBookManager implements PhoneBookManager {
	private final static PhoneBookManager instance = new MockPhoneBookManager();
	
	private static List<PhoneBookEntry> allPhoneBookEntries = new ArrayList<PhoneBookEntry>(10);
	private static final int MAX_NUM = 10; 
	
	static {
		allPhoneBookEntries.add(new PhoneBookEntry("Janet", "13222931216", "021-67859012"));
		allPhoneBookEntries.add(new PhoneBookEntry("Rex", "13567943272", "021-56093461"));
		allPhoneBookEntries.add(new PhoneBookEntry("Ivan", "13867943272", "021-66092467"));
		allPhoneBookEntries.add(new PhoneBookEntry("Forrest", "13967943346", "021-32092498"));
		allPhoneBookEntries.add(new PhoneBookEntry("Alan", "13267943346", "021-52092498"));
		allPhoneBookEntries.add(new PhoneBookEntry("Shawn", "13663363346", "021-90832498"));
		allPhoneBookEntries.add(new PhoneBookEntry("Jeff", "13767943346", "021-34592498"));
		allPhoneBookEntries.add(new PhoneBookEntry("Simon", "18967943346", "021-76592498"));
		allPhoneBookEntries.add(new PhoneBookEntry("Tony", "18788243346", "021-39562498"));
		allPhoneBookEntries.add(new PhoneBookEntry("Peter", "18536243346", "021-87562498"));
	}
	
	private MockPhoneBookManager() {}
	
	public static synchronized PhoneBookManager getInstance() {
		return instance;
	}
	@Override
	public List<PhoneBookEntry> query(String phoneBookName) {
		Random random = new Random();
		int startIndex = (int) (((MAX_NUM-1) * random.nextDouble()) % MAX_NUM);
		
		List<PhoneBookEntry> entries = new ArrayList<PhoneBookEntry>(4);
		entries.add(allPhoneBookEntries.get(startIndex));
		entries.add(allPhoneBookEntries.get((++ startIndex) % MAX_NUM));
		entries.add(allPhoneBookEntries.get((++ startIndex) % MAX_NUM));
		entries.add(allPhoneBookEntries.get((++ startIndex) % MAX_NUM));
		
		return entries;
	}
}
